/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0oneiric-20140920-0118/msg/Touch.msg
 *
 */


#ifndef JSK_GUI_MSGS_MESSAGE_TOUCH_H
#define JSK_GUI_MSGS_MESSAGE_TOUCH_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace jsk_gui_msgs
{
template <class ContainerAllocator>
struct Touch_
{
  typedef Touch_<ContainerAllocator> Type;

  Touch_()
    : finger_id(0)
    , x(0.0)
    , y(0.0)
    , image_width(0)
    , image_height(0)  {
    }
  Touch_(const ContainerAllocator& _alloc)
    : finger_id(0)
    , x(0.0)
    , y(0.0)
    , image_width(0)
    , image_height(0)  {
    }



   typedef int64_t _finger_id_type;
  _finger_id_type finger_id;

   typedef double _x_type;
  _x_type x;

   typedef double _y_type;
  _y_type y;

   typedef int64_t _image_width_type;
  _image_width_type image_width;

   typedef int64_t _image_height_type;
  _image_height_type image_height;




  typedef boost::shared_ptr< ::jsk_gui_msgs::Touch_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_gui_msgs::Touch_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Touch_

typedef ::jsk_gui_msgs::Touch_<std::allocator<void> > Touch;

typedef boost::shared_ptr< ::jsk_gui_msgs::Touch > TouchPtr;
typedef boost::shared_ptr< ::jsk_gui_msgs::Touch const> TouchConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_gui_msgs::Touch_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_gui_msgs::Touch_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_gui_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'jsk_gui_msgs': ['/tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0oneiric-20140920-0118/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::Touch_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::Touch_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::Touch_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d96a284d39fcc410f375ac68fd380177";
  }

  static const char* value(const ::jsk_gui_msgs::Touch_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd96a284d39fcc410ULL;
  static const uint64_t static_value2 = 0xf375ac68fd380177ULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_gui_msgs/Touch";
  }

  static const char* value(const ::jsk_gui_msgs::Touch_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# finger_id\n\
int64 finger_id\n\
# touch point(screen point)\n\
float64 x\n\
float64 y\n\
# based image size (usually not needed)\n\
int64 image_width\n\
int64 image_height\n\
";
  }

  static const char* value(const ::jsk_gui_msgs::Touch_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.finger_id);
      stream.next(m.x);
      stream.next(m.y);
      stream.next(m.image_width);
      stream.next(m.image_height);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Touch_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_gui_msgs::Touch_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_gui_msgs::Touch_<ContainerAllocator>& v)
  {
    s << indent << "finger_id: ";
    Printer<int64_t>::stream(s, indent + "  ", v.finger_id);
    s << indent << "x: ";
    Printer<double>::stream(s, indent + "  ", v.x);
    s << indent << "y: ";
    Printer<double>::stream(s, indent + "  ", v.y);
    s << indent << "image_width: ";
    Printer<int64_t>::stream(s, indent + "  ", v.image_width);
    s << indent << "image_height: ";
    Printer<int64_t>::stream(s, indent + "  ", v.image_height);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_GUI_MSGS_MESSAGE_TOUCH_H
